/*
    ITmages  upload client for Windows
    Copyright (C) 2011 Dmitriy Simbiriatin <slpiv@itmages.ru>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <windows.h>
#include "errorshandler.h"

wchar_t *AcpToWide(char *string)
{
    int len = MultiByteToWideChar(CP_ACP, 0, string, -1, NULL, 0);
    wchar_t *buffer = (wchar_t*) malloc(len * sizeof(wchar_t));
    if (buffer == NULL) {
        ErrorsHandler(ERROR_MEMALLOC);
        exit(EXIT_FAILURE);
    }
    MultiByteToWideChar(CP_ACP, 0, string, -1, buffer, len);
    return buffer;
}

char *WideToAcp(wchar_t *string)
{
    int len = WideCharToMultiByte(CP_ACP, 0, string, -1, NULL, 0, 0, 0);
    char *buffer = (char*) malloc(len * sizeof(char));
    if (buffer == NULL) {
        ErrorsHandler(ERROR_MEMALLOC);
        exit(EXIT_FAILURE);
    }
    WideCharToMultiByte(CP_ACP, 0, string, -1, buffer, len, 0, 0);
    return buffer;
}

wchar_t *Utf8ToWide(char *string)
{
    int len = MultiByteToWideChar(CP_UTF8, 0, string, -1, NULL, 0);
    wchar_t *buffer = (wchar_t*) malloc(len * sizeof(wchar_t));
    if (buffer == NULL) {
        ErrorsHandler(ERROR_MEMALLOC);
        exit(EXIT_FAILURE);
    }
    MultiByteToWideChar(CP_UTF8, 0, string, -1, buffer, len);
    return buffer;
}

char *WideToUtf8(wchar_t *string)
{
    int len = WideCharToMultiByte(CP_UTF8, 0, string, -1, NULL, 0, 0, 0);
    char *buffer = (char*) malloc(len * sizeof(char));
    if (buffer == NULL) {
        ErrorsHandler(ERROR_MEMALLOC);
        exit(EXIT_FAILURE);
    }
    WideCharToMultiByte(CP_UTF8, 0, string, -1, buffer, len, 0, 0);
    return buffer;
}
